<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.playlet.system.mapper.PublicUserRecordMapper">

    <resultMap type="PublicUserRecord" id="PublicUserRecordResult">
        <result property="id"    column="id"    />
        <result property="name"    column="name"    />
        <result property="unionId"    column="union_id"    />
        <result property="beginTime"    column="begin_time"    />
        <result property="endTime"    column="end_time"    />
        <result property="publicName"    column="public_name"    />
        <result property="publicId"    column="public_id"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectPublicUserRecordVo">
        select id, name, union_id, begin_time, end_time, public_name, public_id, create_by, create_time, update_by, update_time, remark from public_user_record
    </sql>

    <select id="selectPublicUserRecordList" parameterType="PublicUserRecord" resultMap="PublicUserRecordResult">
        <include refid="selectPublicUserRecordVo"/>
        <where>
            <if test="name != null  and name != ''"> and name like concat('%', #{name}, '%')</if>
            <if test="unionId != null  and unionId != ''"> and union_id = #{unionId}</if>
            <if test="beginTime != null "> and begin_time = #{beginTime}</if>
            <if test="endTime != null "> and end_time = #{endTime}</if>
            <if test="publicName != null  and publicName != ''"> and public_name like concat('%', #{publicName}, '%')</if>
            <if test="publicId != null "> and public_id = #{publicId}</if>
        </where>
    </select>

    <select id="selectPublicUserRecordById" parameterType="Long" resultMap="PublicUserRecordResult">
        <include refid="selectPublicUserRecordVo"/>
        where id = #{id}
    </select>

    <insert id="insertPublicUserRecord" parameterType="PublicUserRecord" useGeneratedKeys="true" keyProperty="id">
        insert into public_user_record
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="name != null">name,</if>
            <if test="unionId != null">union_id,</if>
            <if test="beginTime != null">begin_time,</if>
            <if test="endTime != null">end_time,</if>
            <if test="publicName != null">public_name,</if>
            <if test="publicId != null">public_id,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="name != null">#{name},</if>
            <if test="unionId != null">#{unionId},</if>
            <if test="beginTime != null">#{beginTime},</if>
            <if test="endTime != null">#{endTime},</if>
            <if test="publicName != null">#{publicName},</if>
            <if test="publicId != null">#{publicId},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
        </trim>
    </insert>

    <update id="updatePublicUserRecord" parameterType="PublicUserRecord">
        update public_user_record
        <trim prefix="SET" suffixOverrides=",">
            <if test="name != null">name = #{name},</if>
            <if test="unionId != null">union_id = #{unionId},</if>
            <if test="beginTime != null">begin_time = #{beginTime},</if>
            <if test="endTime != null">end_time = #{endTime},</if>
            <if test="publicName != null">public_name = #{publicName},</if>
            <if test="publicId != null">public_id = #{publicId},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deletePublicUserRecordById" parameterType="Long">
        delete from public_user_record where id = #{id}
    </delete>

    <delete id="deletePublicUserRecordByIds" parameterType="String">
        delete from public_user_record where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

</mapper>